## redis 3.0.6

=== src/Makefile ===
# Redis Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file
#
# The Makefile composes the final FINAL_CFLAGS and FINAL_LDFLAGS using
# what is needed for Redis plus the standard CFLAGS and LDFLAGS passed.
# However when building the dependencies (Jemalloc, Lua, Hiredis, ...)
# CFLAGS and LDFLAGS are propagated to the dependencies, so to pass
# flags only to be used when compiling / linking Redis itself REDIS_CFLAGS
# and REDIS_LDFLAGS are used instead (this is the case of 'make gcov').
#
# Dependencies are stored in the Makefile.dep file. To rebuild this file
# Just use 'make dep', but this is only needed by developers.

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
OPTIMIZATION?=-O2
DEPENDENCY_TARGETS=hiredis linenoise lua

# Default settings
STD=-std=c99 -pedantic
WARN=-Wall -W
OPT=$(OPTIMIZATION)

PREFIX?=/usr/local
INSTALL_BIN=$(PREFIX)/bin
INSTALL=install

# Default allocator
ifeq ($(uname_S),Linux)
	MALLOC=jemalloc
else
	MALLOC=libc
endif

# Backwards compatibility for selecting an allocator
ifeq ($(USE_TCMALLOC),yes)
	MALLOC=tcmalloc
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
	MALLOC=tcmalloc_minimal
endif

ifeq ($(USE_JEMALLOC),yes)
	MALLOC=jemalloc
endif

# Override default settings if possible
-include .make-settings

FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS)
FINAL_LDFLAGS=$(LDFLAGS) $(REDIS_LDFLAGS) $(DEBUG)
FINAL_LIBS=-lm
DEBUG=-g -ggdb

ifeq ($(uname_S),SunOS)
	# SunOS
	INSTALL=cp -pf
	FINAL_CFLAGS+= -D__EXTENSIONS__ -D_XPG6
	FINAL_LIBS+= -ldl -lnsl -lsocket -lresolv -lpthread -lrt
else
ifeq ($(uname_S),Darwin)
	# Darwin (nothing to do)
else
ifeq ($(uname_S),AIX)
        # AIX
        FINAL_LDFLAGS+= -Wl,-bexpall
        FINAL_LIBS+= -pthread -lcrypt -lbsd

else
	# All the other OSes (notably Linux)
	FINAL_LDFLAGS+= -rdynamic
	FINAL_LIBS+= -pthread
endif
endif
endif
# Include paths to dependencies
FINAL_CFLAGS+= -I../deps/hiredis -I../deps/linenoise -I../deps/lua/src

ifeq ($(MALLOC),tcmalloc)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc
endif

ifeq ($(MALLOC),tcmalloc_minimal)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc_minimal
endif

ifeq ($(MALLOC),jemalloc)
	DEPENDENCY_TARGETS+= jemalloc
	FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
	FINAL_LIBS+= ../deps/jemalloc/lib/libjemalloc.a -ldl
endif

REDIS_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
REDIS_LD=$(QUIET_LINK)$(CC) $(FINAL_LDFLAGS)
REDIS_INSTALL=$(QUIET_INSTALL)$(INSTALL)

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_INSTALL = @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
endif

REDIS_SERVER_NAME=redis-server
REDIS_SENTINEL_NAME=redis-sentinel
REDIS_SERVER_OBJ=adlist.o ae.o anet.o dict.o redis.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o cluster.o crc16.o endianconv.o slowlog.o scripting.o bio.o rio.o rand.o memtest.o crc64.o bitops.o sentinel.o notify.o setproctitle.o blocked.o hyperloglog.o latency.o sparkline.o
REDIS_CLI_NAME=redis-cli
REDIS_CLI_OBJ=anet.o sds.o adlist.o redis-cli.o zmalloc.o release.o anet.o ae.o crc64.o
REDIS_BENCHMARK_NAME=redis-benchmark
REDIS_BENCHMARK_OBJ=ae.o anet.o redis-benchmark.o sds.o adlist.o zmalloc.o redis-benchmark.o
REDIS_CHECK_DUMP_NAME=redis-check-dump
REDIS_CHECK_DUMP_OBJ=redis-check-dump.o lzf_c.o lzf_d.o crc64.o
REDIS_CHECK_AOF_NAME=redis-check-aof
REDIS_CHECK_AOF_OBJ=redis-check-aof.o

all: $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME)
	@echo ""
	@echo "Hint: It's a good idea to run 'make test' ;)"
	@echo ""

.PHONY: all

# Deps (use make dep to generate this)
include Makefile.dep

dep:
	$(REDIS_CC) -MM *.c > Makefile.dep

.PHONY: dep

persist-settings: distclean
	echo STD=$(STD) >> .make-settings
	echo WARN=$(WARN) >> .make-settings
	echo OPT=$(OPT) >> .make-settings
	echo MALLOC=$(MALLOC) >> .make-settings
	echo CFLAGS=$(CFLAGS) >> .make-settings
	echo LDFLAGS=$(LDFLAGS) >> .make-settings
	echo REDIS_CFLAGS=$(REDIS_CFLAGS) >> .make-settings
	echo REDIS_LDFLAGS=$(REDIS_LDFLAGS) >> .make-settings
	echo PREV_FINAL_CFLAGS=$(FINAL_CFLAGS) >> .make-settings
	echo PREV_FINAL_LDFLAGS=$(FINAL_LDFLAGS) >> .make-settings
	-(cd ../deps && $(MAKE) $(DEPENDENCY_TARGETS))

.PHONY: persist-settings

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything, persist settings and build dependencies if anything changed
ifneq ($(strip $(PREV_FINAL_CFLAGS)), $(strip $(FINAL_CFLAGS)))
.make-prerequisites: persist-settings
endif

ifneq ($(strip $(PREV_FINAL_LDFLAGS)), $(strip $(FINAL_LDFLAGS)))
.make-prerequisites: persist-settings
endif

# redis-server
$(REDIS_SERVER_NAME): $(REDIS_SERVER_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/lua/src/liblua.a $(FINAL_LIBS)

# redis-sentinel
$(REDIS_SENTINEL_NAME): $(REDIS_SERVER_NAME)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME)

# redis-cli
$(REDIS_CLI_NAME): $(REDIS_CLI_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/linenoise/linenoise.o $(FINAL_LIBS)

# redis-benchmark
$(REDIS_BENCHMARK_NAME): $(REDIS_BENCHMARK_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a $(FINAL_LIBS)

# redis-check-dump
$(REDIS_CHECK_DUMP_NAME): $(REDIS_CHECK_DUMP_OBJ)
	$(REDIS_LD) -o $@ $^ $(FINAL_LIBS)

# redis-check-aof
$(REDIS_CHECK_AOF_NAME): $(REDIS_CHECK_AOF_OBJ)
	$(REDIS_LD) -o $@ $^ $(FINAL_LIBS)

# Because the jemalloc.h header is generated as a part of the jemalloc build,
# building it should complete before building any other object. Instead of
# depending on a single artifact, build all dependencies first.
%.o: %.c .make-prerequisites
	$(REDIS_CC) -c $<

clean:
	rm -rf $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME) *.o *.gcda *.gcno *.gcov redis.info lcov-html

.PHONY: clean

distclean: clean
	-(cd ../deps && $(MAKE) distclean)
	-(rm -f .make-*)

.PHONY: distclean

test: $(REDIS_SERVER_NAME) $(REDIS_CHECK_AOF_NAME)
	@(cd ..; ./runtest)

test-sentinel: $(REDIS_SENTINEL_NAME)
	@(cd ..; ./runtest-sentinel)

check: test

lcov:
	$(MAKE) gcov
	@(set -e; cd ..; ./runtest --clients 1)
	@geninfo -o redis.info .
	@genhtml --legend -o lcov-html redis.info

.PHONY: lcov

bench: $(REDIS_BENCHMARK_NAME)
	./$(REDIS_BENCHMARK_NAME)

32bit:
	@echo ""
	@echo "WARNING: if it fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

gcov:
	$(MAKE) REDIS_CFLAGS="-fprofile-arcs -ftest-coverage -DCOVERAGE_TEST" REDIS_LDFLAGS="-fprofile-arcs -ftest-coverage"

noopt:
	$(MAKE) OPTIMIZATION="-O0"

valgrind:
	$(MAKE) OPTIMIZATION="-O0" MALLOC="libc"

src/help.h:
	@../utils/generate-command-help.rb > help.h

install: all
	@mkdir -p $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_BENCHMARK_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CLI_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_DUMP_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_AOF_NAME) $(INSTALL_BIN)
	@ln -sf $(REDIS_SERVER_NAME) $(INSTALL_BIN)/$(REDIS_SENTINEL_NAME)

=== debian/changelog ===
redis (2:3.0.6-1ubuntu0.4) xenial-security; urgency=medium

  * SECURITY UPDATE: heap buffer overflows in Hyperloglog (Closes: #1836496)
    - debian/patches/CVE-2019-10192.patch: Fix hyperloglog corruption
    - CVE-2019-10192

 -- Julian Andres Klode <juliank@ubuntu.com>  Sun, 14 Jul 2019 21:21:22 +0200

redis (2:3.0.6-1ubuntu0.3) xenial-security; urgency=medium

  * SECURITY UPDATE: Tighten Permissions
    - Ensure /var/lib/redis and /var/log/redis are not world readable
    - Set UMask=007 in redis-server.service, redis-sentinel.server
    - Changes taken from Debian version 3:3.2.5-2
    - CVE-2016-2121

 -- Mike Salvatore <mike.salvatore@canonical.com>  Fri, 07 Dec 2018 11:02:30 -0500

redis (2:3.0.6-1ubuntu0.2) xenial-security; urgency=medium

  * SECURITY UPDATE: Permissions issue
    - debian/patches/CVE-2013-7458.patch: fix in
      deps/linenoise/linenoise.c.
    - CVE-2013-7458
  * SECURITY UPDATE: Cross protocol scripting
    - debian/patches/CVE-2016-10517.patch: fix in
      src/redis.c, src/redis.h.
    - CVE-2016-10517
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2017-15047.patch: fix in
      src/cluster.c.
    - CVE-2017-15047
  * SECURITY UPDATE: Memory corruption
    - debian/patches/CVE-2018-11218.patch: fix in
      deps/lua/src/lua_cmsgpack.c.
    - CVE-2018-11218
  * SECURITY UPDATE: Integer Overflow
    - debian/patches/CVE-2018-11219-*.patch: fix in
      deps/lua/src/lua_struct.c.
    - CVE-2018-11219
  * SECURITY UPDATE: Buffer overflow in the redis-cli
    - debian/patches/CVE-2018-12326.patch: fix in
      redis-cli.c.
    - CVE-2018-12326

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 26 Jun 2018 17:12:39 -0300

redis (2:3.0.6-1) unstable; urgency=medium

  * New upstream release.
  * Drop 06-CVE-2015-8080-Integer-wraparound-in-lua_struct.c-cau.patch as an
    equivalent change merged upstream.
  * Don't fail if redis user already exists. (Closes: #774736)

 -- Chris Lamb <lamby@debian.org>  Sat, 19 Dec 2015 11:27:41 +0000

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 libjemalloc-dev [linux-any],
 tcl
Standards-Version: 3.9.6
Homepage: http://redis.io/
Vcs-Git: git://github.com/lamby/pkg-redis.git
Vcs-Browser: https://github.com/lamby/pkg-redis

Package: redis-server
Architecture: any
Depends:
 adduser,
 redis-tools (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: redis-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 ruby-redis
Replaces:
 redis-server (<< 2:2.6.16-1)
Breaks:
 redis-server (<< 2:2.6.16-1)
Description: Persistent key-value database with network interface (client)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

Package: redis-sentinel
Architecture: any
Depends:
 redis-server (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Persistent key-value database with network interface (monitoring)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Redis Sentinel monitoring software.

=== debian/tests/control ===
Test-Command: redis-cli INFO

=== debian/watch ===
version=3
http://redis.io/download http://download.redis.io/releases/redis-(.*).tar.gz

## redis 3.2.0

=== debian/changelog ===
redis (2:3.2.0-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.0
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 06 May 2016 19:02:18 +0000

redis (2:3.0.7-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.7
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Sat, 30 Jan 2016 00:13:31 +0000

redis (2:3.0.6-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.6
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Mon, 21 Dec 2015 23:59:57 +0000

redis (2:3.0.5-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.5
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Thu, 15 Oct 2015 08:24:15 -0700

redis (2:3.0.4-1~dotdeb+8.1) stable; urgency=high

  * Imported Upstream version 3.0.4
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Tue, 08 Sep 2015 07:38:18 -0700

redis (2:3.0.3-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.3
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 17 Jul 2015 03:52:28 -0700

redis (2:3.0.2-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.2

 -- Guillaume Plessis <gui@dotdeb.org>  Thu, 04 Jun 2015 10:25:07 -0700

redis (2:3.0.1-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.0.1

 -- Guillaume Plessis <gui@dotdeb.org>  Tue, 05 May 2015 10:47:19 -0700

redis (2:3.0.0-1~dotdeb+jessie.1) stable; urgency=medium

  * Imported Upstream version 3.0.0
  * Sync with Debian
  * generic Dockerfile to ease Debian packaging

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 03 Apr 2015 17:58:04 -0700

redis (2:2.8.19-1~dotdeb.1) stable; urgency=medium

  * Imported Upstream version 2.8.19
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Tue, 16 Dec 2014 09:58:09 -0800

redis (2:2.8.17-1~dotdeb.1) stable; urgency=medium

  * Imported Upstream version 2.8.17

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 19 Sep 2014 14:33:20 -0700

redis (2:2.8.15-1~dotdeb.1) stable; urgency=medium

  * Imported Upstream version 2.8.15
  * Sync redis.conf with upstream

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 12 Sep 2014 18:01:09 -0700

redis (2:2.8.14-1~dotdeb.1) stable; urgency=medium

  * Imported Upstream version 2.8.14
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 05 Sep 2014 12:55:26 -0700

redis (2:2.8.13-1~dotdeb.1) stable; urgency=low

  * Rebuilt for Dotdeb
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Mon, 14 Jul 2014 20:09:42 -0700

## redis 3.2.1

=== debian/changelog ===
redis (2:3.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Sync debian/redis.conf

 -- Chris Lamb <lamby@debian.org>  Sat, 18 Jun 2016 20:13:44 +0100

redis (2:3.2.0-3) unstable; urgency=medium

  * Skip logging tests as not all architectures support it yet.
  * Tidy patches.

 -- Chris Lamb <lamby@debian.org>  Mon, 16 May 2016 10:28:51 +0100

redis (2:3.2.0-2) unstable; urgency=medium

  * Update redis.conf.

 -- Chris Lamb <lamby@debian.org>  Sat, 07 May 2016 11:05:52 +0100

redis (2:3.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Update 03-use-system-jemalloc.diff.
  * Install redis-check-rdb (was: redis-check-dump).
  * Bump Standards-Version to 3.9.8.

 -- Chris Lamb <lamby@debian.org>  Fri, 06 May 2016 23:55:02 +0100

redis (2:3.0.7-4) unstable; urgency=medium

  * Actually specify a value for LimitNOFILE.

 -- Chris Lamb <lamby@debian.org>  Thu, 07 Apr 2016 11:08:34 +0100

redis (2:3.0.7-3) unstable; urgency=medium

  * Update .travis.yml.
  * Update redis-benchmark manpage. Thanks to Joe Doherty (docapotamus).
  * Add LimitNOFILE to allow a higher number of open file descriptors
    <https://github.com/lamby/pkg-redis/issues/8>. Thanks to @alexber220.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 Apr 2016 15:23:06 +0100

redis (2:3.0.7-2) unstable; urgency=medium

  * Correct SOURCE_DATE_EPOCH patch to invert conditional. Thanks to Reiner
    Herrmann <reiner@reiner-h.de>.

 -- Chris Lamb <lamby@debian.org>  Tue, 02 Feb 2016 10:53:26 +0100

redis (2:3.0.7-1) unstable; urgency=medium

  * New upstream release.
  * Actually drop unused 05-reproducible-build.diff file.
  * Move to https Vcs-Git URI.

 -- Chris Lamb <lamby@debian.org>  Fri, 29 Jan 2016 14:56:43 +0100

redis (2:3.0.6-2) unstable; urgency=medium

  * Ensure that we always properly cleanup test processes (Closes: #808862)
  * Add explicit Build-Depends on procps.
    - Drop explicit pkill.
  * Use SOURCE_DATE_EPOCH instead of dpkg-parsechangelog so patch can go
    upstream.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 Jan 2016 11:38:14 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  debhelper (>= 9),
  dh-systemd (>= 1.5),
  libjemalloc-dev [linux-any],
+ procps,
  tcl
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://redis.io/
-Vcs-Git: git://github.com/lamby/pkg-redis.git
+Vcs-Git: https://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis
 
 Package: redis-server

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

ifneq (,$(filter $(shell dpkg-architecture -qDEB_HOST_ARCH),armel hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390 sparc))
export FORCE_LIBC_MALLOC = yes
endif

%:
	dh $@ --with systemd

override_dh_auto_install:
	debian/bin/generate-parts

override_dh_auto_build:
	dh_auto_build --parallel -- V=1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./runtest
	./runtest-sentinel
endif

override_dh_compress:
	dh_compress -Xredis-trib.rb

clean:
	dh $@
	rm -f src/release.h

## redis 3.2.2

=== debian/changelog ===
redis (2:3.2.2-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.2

 -- Guillaume Plessis <gui@dotdeb.org>  Thu, 28 Jul 2016 14:23:43 +0000

redis (2:3.2.1-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.1

 -- Guillaume Plessis <gui@dotdeb.org>  Sat, 18 Jun 2016 00:33:32 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Guillaume Plessis <gui@dotdeb.org>
 Build-Depends:
  debhelper (>= 9),
  dh-systemd (>= 1.5),
- libjemalloc-dev [linux-any],
  procps,
  tcl
-Standards-Version: 3.9.8
+Standards-Version: 3.9.6
 Homepage: http://redis.io/
-Vcs-Git: https://github.com/lamby/pkg-redis.git
+Vcs-Git: git://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis
 
 Package: redis-server

## redis 3.2.3

=== debian/changelog ===
redis (2:3.2.3-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.3
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Wed, 03 Aug 2016 17:42:22 +0000

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
  dh-systemd (>= 1.5),
  procps,
  tcl
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://redis.io/
-Vcs-Git: git://github.com/lamby/pkg-redis.git
+Vcs-Git: https://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis
 
 Package: redis-server

=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,7 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	# Avoid race conditions in upstream testsuite. (#830500)
 	./runtest
 	./runtest-sentinel
 endif

## redis 3.2.4

=== debian/changelog ===
redis (2:3.2.4-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.4
  * Patches refresh for 3.2.4

 -- Guillaume Plessis <gui@dotdeb.org>  Tue, 27 Sep 2016 17:16:46 +0000

## redis 3.2.5

=== debian/changelog ===
redis (2:3.2.5-1~dotdeb+8.1) stable; urgency=medium

  * Imported Upstream version 3.2.5
  * Sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Wed, 26 Oct 2016 15:55:33 +0000

## redis 3.2.6

=== debian/changelog ===
redis (3:3.2.6-3+deb9u16) stretch-security; urgency=high

  * Non-maintainer upload by the ELTS team.
  * CVE-2025-32023: An authenticated user may have used a specially-crafted
    string to trigger a stack/heap out-of-bounds write during hyperloglog
    operations, potentially leading to remote code execution. Installations
    that used Redis' ACL system to restrict hyperloglog "HLL" commands are
    unaffected by this issue. (Closes: #1108975)
  * CVE-2025-48367: An unauthenticated connection could have caused repeated IP
    protocol errors, leading to client starvation and ultimately become a
    Denial of Service (DoS) attack. (Closes: #1108981)
  * Correct naming/ordering of some existing patches.

 -- Chris Lamb <lamby@debian.org>  Sat, 12 Jul 2025 09:00:09 -0700

redis (3:3.2.6-3+deb9u15) stretch-security; urgency=medium

  * Non-maintainer upload by the ELTS Team.
  * CVE-2025-21605: Limit output buffer for unauthenticated clients

 -- Adrian Bunk <bunk@debian.org>  Sat, 10 May 2025 22:28:19 +0300

redis (3:3.2.6-3+deb9u14) stretch-security; urgency=medium

  * Non-maintainer upload by the ELTS Team.
  * CVE-2024-46981: LUA garbage collector code execution

 -- Adrian Bunk <bunk@debian.org>  Sun, 19 Jan 2025 15:20:41 +0200

redis (3:3.2.6-3+deb9u13) stretch-security; urgency=medium

  * Non-maintainer upload by the ELTS Team.
  * CVE-2022-35977: integer overflows in SETRANGE and SORT
  * CVE-2022-36021: string pattern matching DoS
  * CVE-2023-25155: SRANDMEMBER integer overflow
  * CVE-2024-31228: unbounded pattern matching DoS
  * CVE-2024-31449: Lua bit library stack overflow

 -- Adrian Bunk <bunk@debian.org>  Wed, 27 Nov 2024 02:42:32 +0200

redis (3:3.2.6-3+deb9u12) stretch-security; urgency=high

  * CVE-2023-45145: On startup, Redis began listening on a Unix socket before
    adjusting its permissions to the user-provided configuration. If a
    permissive umask(2) was used, this created a race condition that enabled,
    during a short period of time, another process to establish an otherwise
    unauthorized connection. (Closes: #1054225)
  * Rename an existing patch to include a numerical prefix.

 -- Chris Lamb <lamby@debian.org>  Mon, 23 Oct 2023 13:39:14 +0100

redis (3:3.2.6-3+deb9u11) stretch-security; urgency=high

  * Permit tests to fail; they are segfaulting on the ELTS build server.

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Apr 2023 13:36:01 +0100

redis (3:3.2.6-3+deb9u10) stretch-security; urgency=high

  * CVE-2023-28856: Authenticated users could have used the HINCRBYFLOAT
    command to create an invalid hash field that would have crashed the Redis
    server on access. (Closes: #1034613)

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Apr 2023 13:14:07 +0100

redis (3:3.2.6-3+deb9u9) stretch-security; urgency=high

  * No-change upload to rebuild in stretch environment.

 -- Chris Lamb <lamby@debian.org>  Mon, 08 Nov 2021 09:24:33 +0000

redis (3:3.2.6-3+deb9u8) stretch-security; urgency=high

  * CVE-2021-41099: Integer to heap buffer overflow handling certain string
    commands and network payloads, when proto-max-bulk-len is manually
    configured to a non-default, very large value.
  * CVE-2021-32762: Integer to heap buffer overflow issue in redis-cli and
    redis-sentinel parsing large multi-bulk replies on some older and less
    common platforms.
  * CVE-2021-32687: Integer to heap buffer overflow with intsets, when
    set-max-intset-entries is manually configured to a non-default, very
    large value.
  * CVE-2021-32675: Denial Of Service when processing RESP request payloads
    with a large number of elements on many connections.
  * CVE-2021-32672: Random heap reading issue with Lua Debugger.
  * CVE-2021-32626: Specially crafted Lua scripts may result with Heap
    buffer overflow.

 -- Chris Lamb <lamby@debian.org>  Fri, 05 Nov 2021 10:59:30 +0000

redis (3:3.2.6-3+deb9u7) stretch-security; urgency=high

  * No-change upload to rebuild in stretch environment. (Closes: #993129)

 -- Chris Lamb <lamby@debian.org>  Fri, 27 Aug 2021 17:15:23 +0100

redis (3:3.2.6-3+deb9u6) stretch-security; urgency=high

  * Correct backport of patch for CVE-2021-32761 to prevent build failure.
    Thanks to Adrian Bunk for the heads up.

 -- Chris Lamb <lamby@debian.org>  Fri, 27 Aug 2021 14:37:06 +0100

redis (3:3.2.6-3+deb9u5) stretch-security; urgency=high

  * CVE-2021-32761: Fix several integer overflow issues with BITFIELD commands
    on 32-bit systems. (Closes: #991375)

 -- Chris Lamb <lamby@debian.org>  Thu, 22 Jul 2021 11:08:25 +0100

redis (3:3.2.6-3+deb9u4) stretch-security; urgency=high

  * CVE-2021-21309: Fix a series of integer overflow issues on 32-bit systems.
    (Closes: #983446)

 -- Chris Lamb <lamby@debian.org>  Thu, 25 Feb 2021 17:21:59 +0000

redis (3:3.2.6-3+deb9u3) stretch-security; urgency=high

  * CVE-2019-10192: Fix two heap buffer overflows in the Hyperloglog
    functionality. (Closes: #931625)

 -- Chris Lamb <lamby@debian.org>  Wed, 10 Jul 2019 14:36:26 -0300

redis (3:3.2.6-3+deb9u2) stretch; urgency=medium

  * Correct RunTimeDirectory -> RuntimeDirectory typo in systemd .service
    files. (Closes: #850534, #880474)

 -- Chris Lamb <lamby@debian.org>  Mon, 18 Jun 2018 19:12:58 +0200

redis (3:3.2.6-3+deb9u1) stretch-security; urgency=high

  * CVE-2018-11218, CVE-2018-11219: Backport patches to fix multiple heap
    corruption and integer overflow vulnerabilities. (Closes: #901495)

 -- Chris Lamb <lamby@debian.org>  Thu, 14 Jun 2018 15:08:27 +0200

redis (3:3.2.6-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/gbp.conf to reflect new repository layout.

 -- Chris Lamb <lamby@debian.org>  Tue, 06 Dec 2016 09:23:20 +0000

redis (3:3.2.5-6) unstable; urgency=medium

  * Add missing Depends on lsb-base for /lib/lsb/init-functions usage in
    redis-sentinel's initscript too. See #838966 for the parallel change to
    redis-server's initscript.



=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 export CFLAGS CPPFLAGS LDFLAGS
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -ldl
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -27,8 +28,8 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Avoid race conditions in upstream testsuite. (#830500)
-	./runtest
-	./runtest-sentinel
+	./runtest || true
+	./runtest-sentinel || true
 endif
 
 override_dh_compress:

## redis 3.2.8

=== src/Makefile ===
--- 
+++ 
@@ -15,10 +15,10 @@
 release_hdr := $(shell sh -c './mkreleasehdr.sh')
 uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
 OPTIMIZATION?=-O2
-DEPENDENCY_TARGETS=hiredis linenoise lua
+DEPENDENCY_TARGETS=hiredis linenoise lua geohash-int
 
 # Default settings
-STD=-std=c99 -pedantic
+STD=-std=c99 -pedantic -DREDIS_STATIC=''
 WARN=-Wall -W
 OPT=$(OPTIMIZATION)
 
@@ -46,10 +46,14 @@
 	MALLOC=jemalloc
 endif
 
+ifeq ($(USE_JEMALLOC),no)
+	MALLOC=libc
+endif
+
 # Override default settings if possible
 -include .make-settings
 
-FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS)
+FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS) -I../deps/geohash-int
 FINAL_LDFLAGS=$(LDFLAGS) $(REDIS_LDFLAGS) $(DEBUG)
 FINAL_LIBS=-lm
 DEBUG=-g -ggdb
@@ -61,17 +65,27 @@
 	FINAL_LIBS+= -ldl -lnsl -lsocket -lresolv -lpthread -lrt
 else
 ifeq ($(uname_S),Darwin)
-	# Darwin (nothing to do)
+	# Darwin
+	FINAL_LIBS+= -ldl
 else
 ifeq ($(uname_S),AIX)
         # AIX
         FINAL_LDFLAGS+= -Wl,-bexpall
-        FINAL_LIBS+= -pthread -lcrypt -lbsd
-
+        FINAL_LIBS+=-ldl -pthread -lcrypt -lbsd
+else
+ifeq ($(uname_S),OpenBSD)
+	# OpenBSD
+	FINAL_LIBS+= -lpthread
+else
+ifeq ($(uname_S),FreeBSD)
+	# FreeBSD
+	FINAL_LIBS+= -lpthread
 else
 	# All the other OSes (notably Linux)
 	FINAL_LDFLAGS+= -rdynamic
-	FINAL_LIBS+= -pthread
+	FINAL_LIBS+=-ldl -pthread
+endif
+endif
 endif
 endif
 endif
@@ -91,7 +105,7 @@
 ifeq ($(MALLOC),jemalloc)
 	DEPENDENCY_TARGETS+= jemalloc
 	FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
-	FINAL_LIBS+= ../deps/jemalloc/lib/libjemalloc.a -ldl
+	FINAL_LIBS+= ../deps/jemalloc/lib/libjemalloc.a
 endif
 
 REDIS_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
@@ -113,17 +127,17 @@
 
 REDIS_SERVER_NAME=redis-server
 REDIS_SENTINEL_NAME=redis-sentinel
-REDIS_SERVER_OBJ=adlist.o ae.o anet.o dict.o redis.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o cluster.o crc16.o endianconv.o slowlog.o scripting.o bio.o rio.o rand.o memtest.o crc64.o bitops.o sentinel.o notify.o setproctitle.o blocked.o hyperloglog.o latency.o sparkline.o
+REDIS_SERVER_OBJ=adlist.o quicklist.o ae.o anet.o dict.o server.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o cluster.o crc16.o endianconv.o slowlog.o scripting.o bio.o rio.o rand.o memtest.o crc64.o bitops.o sentinel.o notify.o setproctitle.o blocked.o hyperloglog.o latency.o sparkline.o redis-check-rdb.o geo.o
+REDIS_GEOHASH_OBJ=../deps/geohash-int/geohash.o ../deps/geohash-int/geohash_helper.o
 REDIS_CLI_NAME=redis-cli
-REDIS_CLI_OBJ=anet.o sds.o adlist.o redis-cli.o zmalloc.o release.o anet.o ae.o crc64.o
+REDIS_CLI_OBJ=anet.o adlist.o redis-cli.o zmalloc.o release.o anet.o ae.o crc64.o
 REDIS_BENCHMARK_NAME=redis-benchmark
-REDIS_BENCHMARK_OBJ=ae.o anet.o redis-benchmark.o sds.o adlist.o zmalloc.o redis-benchmark.o
-REDIS_CHECK_DUMP_NAME=redis-check-dump
-REDIS_CHECK_DUMP_OBJ=redis-check-dump.o lzf_c.o lzf_d.o crc64.o
+REDIS_BENCHMARK_OBJ=ae.o anet.o redis-benchmark.o adlist.o zmalloc.o redis-benchmark.o
+REDIS_CHECK_RDB_NAME=redis-check-rdb
 REDIS_CHECK_AOF_NAME=redis-check-aof
 REDIS_CHECK_AOF_OBJ=redis-check-aof.o
 
-all: $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME)
+all: $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_RDB_NAME) $(REDIS_CHECK_AOF_NAME)
 	@echo ""
 	@echo "Hint: It's a good idea to run 'make test' ;)"
 	@echo ""
@@ -168,12 +182,16 @@
 
 # redis-server
 $(REDIS_SERVER_NAME): $(REDIS_SERVER_OBJ)
-	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/lua/src/liblua.a $(FINAL_LIBS)
+	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/lua/src/liblua.a $(REDIS_GEOHASH_OBJ) $(FINAL_LIBS)
 
 # redis-sentinel
 $(REDIS_SENTINEL_NAME): $(REDIS_SERVER_NAME)
 	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME)
 
+# redis-check-rdb
+$(REDIS_CHECK_RDB_NAME): $(REDIS_SERVER_NAME)
+	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_CHECK_RDB_NAME)
+
 # redis-cli
 $(REDIS_CLI_NAME): $(REDIS_CLI_OBJ)
 	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/linenoise/linenoise.o $(FINAL_LIBS)
@@ -181,10 +199,6 @@
 # redis-benchmark
 $(REDIS_BENCHMARK_NAME): $(REDIS_BENCHMARK_OBJ)
 	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a $(FINAL_LIBS)
-
-# redis-check-dump
-$(REDIS_CHECK_DUMP_NAME): $(REDIS_CHECK_DUMP_OBJ)
-	$(REDIS_LD) -o $@ $^ $(FINAL_LIBS)
 
 # redis-check-aof
 $(REDIS_CHECK_AOF_NAME): $(REDIS_CHECK_AOF_OBJ)
@@ -197,7 +211,7 @@
 	$(REDIS_CC) -c $<
 
 clean:
-	rm -rf $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME) *.o *.gcda *.gcno *.gcov redis.info lcov-html
+	rm -rf $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_RDB_NAME) $(REDIS_CHECK_AOF_NAME) *.o *.gcda *.gcno *.gcov redis.info lcov-html
 
 .PHONY: clean
 
@@ -221,6 +235,10 @@
 	@geninfo -o redis.info .
 	@genhtml --legend -o lcov-html redis.info
 
+test-sds: sds.c sds.h
+	$(REDIS_CC) sds.c zmalloc.c -DSDS_TEST_MAIN -o /tmp/sds_test
+	/tmp/sds_test
+
 .PHONY: lcov
 
 bench: $(REDIS_BENCHMARK_NAME)
@@ -249,6 +267,6 @@
 	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(INSTALL_BIN)
 	$(REDIS_INSTALL) $(REDIS_BENCHMARK_NAME) $(INSTALL_BIN)
 	$(REDIS_INSTALL) $(REDIS_CLI_NAME) $(INSTALL_BIN)
-	$(REDIS_INSTALL) $(REDIS_CHECK_DUMP_NAME) $(INSTALL_BIN)
+	$(REDIS_INSTALL) $(REDIS_CHECK_RDB_NAME) $(INSTALL_BIN)
 	$(REDIS_INSTALL) $(REDIS_CHECK_AOF_NAME) $(INSTALL_BIN)
 	@ln -sf $(REDIS_SERVER_NAME) $(INSTALL_BIN)/$(REDIS_SENTINEL_NAME)

=== debian/changelog ===
redis (3:3.2.8-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Mar 2017 12:55:09 +0000

redis (3:3.2.8-2) unstable; urgency=medium

  * Avoid conflict between RuntimeDirectory and tmpfiles.d(5) both attempting
    to create /run/redis with differing permissions.

    This prevents an installation error on Jessie where /run/redis was first
    being created by the tmpfiles.d(5) mechanism and then subsequently via the
    RuntimeDirectory directive. Due to a bug in Jessie's systemd, this caused a
    package installation error as systemd was too strict about permissions if
    the target already exists: <https://github.com/systemd/systemd/pull/896>

    The redis-{server,sentinel} daemon would actually start successfully a few
    milliseconds later due to the Restart=always directive.

    We work around this this by dropping the tmpfiles.d(5) handling and moving
    entirely to RuntimeDirectory{,Mode}; we are not using any special handling
    requiring tmpfiles.d(5) and we appear to need RuntimeDirectory anyway for
    #846350. (Closes: #856116)

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Mar 2017 12:53:14 +0000

redis (3:3.2.8-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 13 Feb 2017 10:15:53 +1300

redis (3:3.2.7-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 01 Feb 2017 09:27:05 +1300

redis (3:3.2.6-6) unstable; urgency=medium

  * Use --cpu-list 0 (not --cpu-list 1) to ensure compilation on single-CPU
    machines. (Closes: #852347)

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Jan 2017 11:59:02 +1300

redis (3:3.2.6-5) unstable; urgency=medium

  * Re-add taskset calls to try and avoid FTBFS due to parallelism in upstream
    test suite.

 -- Chris Lamb <lamby@debian.org>  Mon, 23 Jan 2017 13:24:39 +1300

redis (3:3.2.6-4) unstable; urgency=medium

  * Expand the documentation in redis-server.service and redis-sentinel
    regarding the default hardening options.

 -- Chris Lamb <lamby@debian.org>  Sat, 21 Jan 2017 11:21:33 +1100

redis (3:3.2.6-3) unstable; urgency=medium

  * Don't ship a "duplicate" redis-server binary in redis-tools as
    /usr/bin/redis-check-rdb (it checks argv to change its behaviour) by
    replacing it with a symlink. Found by <https://dedup.debian.net/>.

 -- Chris Lamb <lamby@debian.org>  Wed, 11 Jan 2017 17:04:33 +0000

redis (3:3.2.6-2) unstable; urgency=medium

  * Rename RunTimeDirectory -> RuntimeDirectory in .service files.
    (Closes: #850534)
  * Refresh all patches with pq import -> pq export.
  * Tidy all patches, updating descriptions and use Pq-Topic to organise.

 -- Chris Lamb <lamby@debian.org>  Sat, 07 Jan 2017 18:06:14 +0000

redis (3:3.2.6-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Sun, 18 Dec 2016 09:59:19 +0000

redis (3:3.2.5-4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Tue, 29 Nov 2016 16:42:08 +0000

redis (3:3.2.5-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Thu, 10 Nov 2016 12:01:35 +0000

redis (3:3.2.5-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Tue, 01 Nov 2016 16:42:50 +0000

redis (3:3.2.4-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Mon, 03 Oct 2016 17:43:43 +0100

redis (3:3.2.3-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Sun, 11 Sep 2016 20:51:52 +0100

redis (2:3.2.3-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Aug 2016 10:34:24 +0100

redis (2:3.2.1-4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Thu, 28 Jul 2016 08:49:42 -0400

redis (2:3.2.1-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 27 Jul 2016 23:52:42 -0400

redis (2:3.2.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 29 Jun 2016 14:15:07 +0200

redis (2:3.2.0-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Jun 2016 11:51:23 +0100

redis (2:3.2.0-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
    - Drop debian/patches/05-CVE-2015-4335.patch.

 -- Chris Lamb <lamby@debian.org>  Sat, 14 May 2016 09:22:01 +0100

redis (2:2.8.17-1+deb8u2) stable; urgency=medium

  * Backport debian/redis-server.tmpfile from unstable so that a valid runtime
    directory is created when running under systemd. This ensures that there is
    a secure and sensible location for the UNIX socket. (Closes: #803233)

 -- Chris Lamb <lamby@debian.org>  Fri, 30 Oct 2015 18:53:34 +0000

redis (2:2.8.17-1+deb8u1) jessie-security; urgency=high

  * Fix Lua sandbox bypass by disabling Lua bytecode loading
    as per CVE-2015-4335

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 05 Jun 2015 15:12:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Guillaume Plessis <gui@dotdeb.org>
+Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  debhelper (>= 9),
  dh-systemd (>= 1.5),
+ libjemalloc-dev [linux-any],
  procps,
  tcl
 Standards-Version: 3.9.8
@@ -16,6 +17,7 @@
 Architecture: any
 Depends:
  adduser,
+ lsb-base (>= 3.2-14),
  redis-tools (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
@@ -47,6 +49,7 @@
 Package: redis-sentinel
 Architecture: any
 Depends:
+ lsb-base (>= 3.2-14),
  redis-server (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,8 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Avoid race conditions in upstream testsuite. (#830500)
-	./runtest || true
-	./runtest-sentinel || true
+	taskset --cpu-list 0 ./runtest
+	taskset --cpu-list 0 ./runtest-sentinel
 endif
 
 override_dh_compress:

=== debian/tests/control ===
Test-Command: redis-cli INFO && redis-benchmark -P 10

## redis 3.2.9

=== debian/changelog ===
redis (2:3.2.9-1~dotdeb+8.1) stable; urgency=medium

  [ Guillaume Plessis ]
  * Imported Upstream version 3.2.9

 -- Guillaume Plessis <gui@dotdeb.org>  Mon, 22 May 2017 16:47:53 +0000

redis (2:3.2.8-1~dotdeb+8.1) stable; urgency=medium

  [ Guillaume Plessis ]
  * Imported Upstream version 3.2.8

 -- Guillaume Plessis <gui@dotdeb.org>  Wed, 15 Feb 2017 01:57:13 +0000

redis (2:3.2.7-1~dotdeb+8.1) stable; urgency=medium

  [ Guillaume Plessis ]
  * Imported Upstream version 3.2.7

 -- Guillaume Plessis <gui@dotdeb.org>  Tue, 31 Jan 2017 18:36:56 +0000

redis (2:3.2.6-1~dotdeb+8.1) stable; urgency=medium

  [ Guillaume Plessis ]
  * Imported Upstream version 3.2.6
  * (Last?) sync with Debian

 -- Guillaume Plessis <gui@dotdeb.org>  Thu, 08 Dec 2016 20:23:54 +0000

## redis 3.2.10

=== debian/changelog ===
redis (2:3.2.10-1~dotdeb+8.1) oldstable; urgency=medium

  [ Guillaume Plessis ]
  * Stick to the 3.2 branch
  * Imported Upstream version 3.2.10

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 28 Jul 2017 17:40:31 +0000

## redis 3.2.11

=== debian/changelog ===
redis (2:3.2.11-1~dotdeb+8.1) oldstable; urgency=medium

  [ Guillaume Plessis ]
  * New upstream version 3.2.11

 -- Guillaume Plessis <gui@dotdeb.org>  Fri, 22 Sep 2017 18:07:39 +0000

=== debian/watch ===
version=3
http://redis.io/download http://download.redis.io/releases/redis-(3.2.*).tar.gz

## redis 4.0.1

=== debian/changelog ===
redis (4:4.0.1-7) unstable; urgency=medium

  * Don't let sentinel tests fail the build; they use too many timers to be
    useful and/or meaningful. (Closes: #872075)

 -- Chris Lamb <lamby@debian.org>  Mon, 14 Aug 2017 07:35:38 -0700

redis (4:4.0.1-6) unstable; urgency=medium

  * Don't install completions to
    /usr/share/bash-completion/completions/debian/bash_completion/.

 -- Chris Lamb <lamby@debian.org>  Sun, 13 Aug 2017 21:29:07 -0700

redis (4:4.0.1-5) unstable; urgency=medium

  * Tidy debian/tests/control.
  * Drop even more tests with timing issues.

 -- Chris Lamb <lamby@debian.org>  Sun, 13 Aug 2017 13:02:52 -0700

redis (4:4.0.1-4) unstable; urgency=medium

  * Split tests into separate files.
  * Tighten systemd/seccomp hardening.

 -- Chris Lamb <lamby@debian.org>  Sat, 12 Aug 2017 12:53:50 -0400

redis (4:4.0.1-3) unstable; urgency=medium

  * Drop yet more non-deterministic tests.

 -- Chris Lamb <lamby@debian.org>  Sat, 05 Aug 2017 21:01:03 -0400

redis (4:4.0.1-2) unstable; urgency=medium

  * Skip yet more non-deterministic replication tests that rely on timing.
    (Closes: #857855)

 -- Chris Lamb <lamby@debian.org>  Tue, 25 Jul 2017 18:57:39 +0100

redis (4:4.0.1-1) unstable; urgency=medium

  * New upstream version.
  * Install 00-RELEASENOTES as the upstream changelog.
  * Use "dh_auto_clean" over "clean" target.

 -- Chris Lamb <lamby@debian.org>  Mon, 24 Jul 2017 16:27:51 +0100

redis (4:4.0.0-3) unstable; urgency=medium

  * Add -latomic to LDFLAGS to attempt to avoid FTBFS on mips{,el}.
  * Allow ulimit calls to fail in sysvinit scripts to avoid issues when
    running in a containerised environment. See
    <https://github.com/travis-ci/travis-ci/issues/7941>.

 -- Chris Lamb <lamby@debian.org>  Sun, 23 Jul 2017 15:42:18 +0100

redis (4:4.0.0-2) unstable; urgency=medium

  * Make /usr/bin/redis-server in the main redis-server package a symlink to
    /usr/bin/redis-check-rdb in the redis-tools package.

    Whilst this prevents a wasteful duplication of a binary, it moreover
    ensures there are no duplicate debug symbols which was preventing the
    simultaneous installation of the redis-server-dbgsym and
    redis-tools-dbgsym packages.

    Note that this results in the peculiar (and possibily confusing) situation
    where the main package does not have the main binary anymore, or indeed
    any binaries whatsoever. See also the previous parallel attempt at a
    symlink changes in 3.2.6-3 which was reverted in 3.2.8-3. Thanks to Adrian
    Bunk for the report. (Closes: #868551)

 -- Chris Lamb <lamby@debian.org>  Sun, 16 Jul 2017 22:38:57 +0100

redis (4:4.0.0-1) unstable; urgency=medium

  * New upstream major release.
  * Bump Standards-Version to 4.0.0.
  * Refresh, renumber and reorganise patches.

 -- Chris Lamb <lamby@debian.org>  Fri, 14 Jul 2017 22:00:59 +0100

redis (3:3.2.9-1) unstable; urgency=medium

  * New upstream minor bugfix release.
  * Specify <!nocheck> for test-related Build-Depends.
  * Bump debhelper compatibility level to 10.

 -- Chris Lamb <lamby@debian.org>  Thu, 18 May 2017 12:32:02 +0200

redis (3:3.2.8-3) unstable; urgency=medium

  * Revert the creation of the redis-tools:/usr/bin/redis-check-rdb ->
    redis-server:/usr/bin/redis-server symlink to avoid a dangling symlink if
    only the redis-tools binary package is installed.

    This was a regression since 3:3.2.6-3 where we attempted to avoid shipping
    duplicate file; the redis-server binary changes behaviour based on the
    contents of argv.

    One alternative would be to ship a symlink in redis-server but that would
    mean users wishing to check RDB databases would have to install the server
    package, so reverting to shipping a duplicate file seems justified.
    (Closes: #858519)

 -- Chris Lamb <lamby@debian.org>  Thu, 23 Mar 2017 12:00:22 +0000

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 10),
  dh-systemd (>= 1.5),
+ dpkg-dev (>= 1.17.14),
  libjemalloc-dev [linux-any],
- procps,
- tcl
-Standards-Version: 3.9.8
+ procps <!nocheck>,
+ tcl <!nocheck>
+Standards-Version: 4.0.0
 Homepage: http://redis.io/
 Vcs-Git: https://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export CFLAGS CPPFLAGS LDFLAGS
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -ldl
+export DEB_LDFLAGS_MAINT_APPEND = -ldl -latomic
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -29,12 +29,17 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Avoid race conditions in upstream testsuite. (#830500)
 	taskset --cpu-list 0 ./runtest
-	taskset --cpu-list 0 ./runtest-sentinel
+	# Sentinel integration tests use too many timers to be reliable or
+	# meaningful.
+	taskset --cpu-list 0 ./runtest-sentinel || true
 endif
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f src/release.h
 
 override_dh_compress:
 	dh_compress -Xredis-trib.rb
 
-clean:
-	dh $@
-	rm -f src/release.h
+override_dh_installchangelogs:
+	dh_installchangelogs --keep 00-RELEASENOTES

=== debian/tests/control ===
Tests: 0001-redis-cli

Tests: 0002-benchmark
